routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
|
*/

Route::get('/', function () {
    return redirect()->route('login');
});
Route::get('/tes', 'TesController@index');
Route::livewire('/users', 'user.index')->name('users.index');
Auth::routes(['regiter' => true]);
Route::get('/home', 'HomeController@index')->name('home');
Route::group(['middleware' => ['auth', 'status'], 'prefix' => 'admin'], function () {
    Route::resource('user', 'UsersController');
    Route::post('user/api', 'UsersController@list')->name('user.api');
    Route::group(['prefix' => 'acl'], function () {
        Route::get('/', 'RoleController@index')
            ->name('access');
        Route::resource('role', 'RoleController');
        Route::get('show/permission/role', 'RoleController@rolePermission')->name('role.permisiion');
        Route::post('show/permission/role/set', 'RoleController@setRolePermission')->name('role.permisiion.set');
        Route::post('api/role', 'RoleController@roleList')->name('api.role');
        Route::resource('permission', 'PermissionController');
        Route::post('api/permission', 'PermissionController@permissionList')->name('api.permission');
    });
    Route::group(['prefix' => 'jawaban'], function () {
        Route::get('all', 'JawabanController@prima')->name('prima');
        Route::post('all', 'JawabanController@prima')->name('prima');
    });
});
Route::get('lang/{language}', 'LocalizationController@switch')->name('localization.switch');
Route::post('api/login', 'AuthApiController@login')->name('api.login');
Route::get('daftar', 'AuthApiController@daftar')->name('daftar');
Route::post('daftar', 'AuthApiController@daftar')->name('daftar');
Route::post('cek/pajak', 'AuthApiController@pajak')->name('pajak');

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Spatie\Permission\Traits\HasRoles;
use App\Traits\Uuid;
use Illuminate\Database\Eloquent\Relations\HasOne;
use DB;

class User extends Authenticatable
{
    use Notifiable, HasRoles, Uuid;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'first_name', 'last_name', 'email', 'password', 'status', 'term'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function profile()
    {
        return $this->hasOne(Profile::class);
    }
    public function credit()
    {
        return $this->hasOne(CreditCard::class);
    }
    public function alamat()
    {
        return $this->hasMany(Addres::class);
    }
}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\MemberType;
use Illuminate\Http\Request;
use App\User;
use Spatie\Permission\Models\Role;
use Validator;
use DataTables;
use DB;

class UsersController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.user.index');
    }
    public function list(Request $req)
    {
        $data = User::with(['profile', 'credit'])->get();

        return Datatables::of($data)
            ->addIndexColumn()
            ->escapeColumns([])


            ->addColumn('type', function ($data) {
                $id = $data->profile->member_type_id;
                $t = MemberType::where('id', $id)->first();
                return $t->name;
            })
            ->editColumn('created_at', function ($data) {
                return tgl_indo($data->created_at);
            })
            ->addColumn('gender', function ($data) {
                if ($data->profile->gender == 1) {
                    return "Laki-laki";
                } else {
                    return "Perempuan";
                }
            })
            ->addColumn('pajak', function ($data) {
                $id = $data->profile->member_type_id;
                $umur = umur($data->profile->dob);
                $jk = $data->profile->gender;
                $t = MemberType::where('id', $id)->first();
                if ($id == 2 and $umur > 16 and $jk == 2) {
                    return "Bebas Pajak";
                } else {
                    return $t->tax . ' %';
                }
                if ($id == 1 and $umur > 19 and $jk == 2) {
                    return "Bebas Pajak";
                } else {
                    return $t->tax . ' %';
                }
                if ($id == 3 and $umur > 21 and $jk == 2) {
                    return "Bebas Pajak";
                } else {
                    return $t->tax;
                }
            })
            ->addColumn('cc', function ($data) {
                return $data->credit->no_cc;
            })
            ->editColumn('status', function ($data) {
                if ($data->status == 1) {
                    return 'Aktif';
                } else {
                    return 'Suspend';
                }
            })

            ->editColumn('first_name', function ($data) {
                return $data->first_name . " " . $data->last_name . " (" . umur($data->profile->dob) . "th)";
            })

            ->addColumn('action', function ($data) {
                return '<div class="dropdown custom-dropdown">
                                                        <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
                                                            <i class="flaticon-dot-three"></i>
                                                        </a>

                                                        <div class="dropdown-menu" aria-labelledby="dropdownMenuLink1">

                                                            <a class="dropdown-item" href="' . route('user.edit', $data->uuid) . '" data-toggle="modal" data-target="#myModal">Edit</a>
                                                            <a class="dropdown-item" onclick="hapus(' . "'$data->id'" . ')">Delete</a>

                                                        </div>
                                                    </div>';
            })

            ->make(true);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $role = Role::orderBy('name', 'ASC')->get();
        return view('admin.user.create', compact('role'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $req)
    {
        $valid = Validator::make($req->all(), [
            'nama' => 'required|string|max:100',
            'email' => 'required|email|unique:users',
            'password' => 'required|min:6',
            'role' => 'required|exists:roles,name'
        ]);
        if ($valid->fails()) {
            return response()->json(['status' => 'error', 'code' => 400, 'msg' => $valid->messages()->first()]);
        }
        $user = User::firstOrCreate([
            'email' => $req->email
        ], [
            'name' => $req->nama,
            'password' => bcrypt($req->password),
            'status' => true
        ]);
        $user->assignRole([$req->role]);
        return response()->json(['status' => 'success', 'msg' => "Berhasil"]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data = User::where('uuid', $id)->first();
        $role = Role::all()->pluck('name');
        return view('admin.user.edit', compact('data', 'role'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $valid = Validator::make($request->all(), [
            'nama' => 'required|string|max:100',
            'email' => 'required|email|exists:users,email',
            'password' => 'nullable|min:6',
            'role' => 'required|exists:roles,name'
        ]);
        if ($valid->fails()) {
            return response()->json(['status' => 'error', 'code' => 400, 'msg' => $valid->messages()->first()]);
        }
        $user = User::findOrFail($id);
        $password = !empty($request->password) ? bcrypt($request->password) : $user->password;
        $user->update([
            'name' => $request->nama,
            'password' => $password,
            'status' => $request->status
        ]);
        $user->syncRoles([$request->role]);
        return response()->json(['status' => 'success', 'msg' => "Berhasil"]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //User::destroy($id);

        //return response()->json(['status' => 'success', 'msg' => "Berhasil"]);
    }
}

app/Http/Livewire/User/Index.php
<?php

namespace App\Http\Livewire\User;

use Livewire\Component;
use Illuminate\Http\Request;
use DB;
class Index extends Component
{
    public function render()
    {
        return view('livewire.user.index');
    }
    function store(Request $req){

    }
    public function dataList(Request $req){

    }
}

resources/views/admin/user/create.blade.php
<div class="modal-header">
    <h5 class="modal-title" id="myExtraLargeModalLabel">Form</h5>
    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">×</span>
    </button>
</div>
<form method="POST" id="form_data">
    <div class="modal-body">
        <div class="form-row mb-4">
            <div class="form-group col-md-6">
                <label for="inputEmail4">{{trans('nama')}}</label>
                <input type="text" class="form-control-rounded form-control" name="nama"
                    placeholder="{{trans('nama')}}">
            </div>
            <div class="form-group col-md-6">
                <label for="inputEmail4">{{trans('email')??"Email"}}</label>
                <input type="email" class="form-control-rounded form-control" name="email" placeholder="Email">
            </div>
            <div class="form-group col-md-6">
                <label for="inputPassword4">Password</label>
                <input type="password" class="form-control-rounded form-control" id="inputPassword4"
                    placeholder="Password" name="password">
            </div>
            <div class="form-group col-md-6">
                <label for="inputPassword4">Role</label>
                <select name="role[]" class="select2 form-control-rounded form-control" multiple>
                    <option value=""></option>
                    @foreach ($role as $key)
                    <option value="{{$key->name}}">{{$key->name}}</option>

                    @endforeach
                </select>
            </div>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-dark btn-rounded mt-3 mb-3" data-dismiss="modal">Close</button>
            <button type="submit" class="btn btn-primary btn-rounded mt-3 mb-3">Submit</button>
        </div>
    </div>
</form>
<script>
    $(".select2").select2({
    placeholder: "Pilih",
    allowClear: true
    });

    $("#form_data").submit(function (e) {
        e.preventDefault();
       $('#myModal').modal('hide')
        var form=$("#form_data").serialize();
       $.ajax({
           type: "POST",
           url: "{{route('user.store')}}",
           data: form,
           dataType: "JSON",
           success: function (response) {
            if (response.status!="error") {
                Toast.fire({
                icon: 'success',
                title: response.msg
                });
                myTable.ajax.reload();
            } else {
                Swal.fire({
                position: 'top-end',
                icon: 'error',
                title: response.msg,
                showConfirmButton: false,
                showCloseButton:true
                })
            }
           },
           error:function(response)
           {
            Swal.fire({
                position: 'top-end',
                icon: 'error',
                title: response.msg,
                showConfirmButton: false,
                showCloseButton:true
                })
           }
       });
    });
</script>

resources/views/admin/user/edit.blade.php
<div class="modal-header">
    <h5 class="modal-title" id="myExtraLargeModalLabel">Form</h5>
    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">×</span>
    </button>
</div>
<form method="POST" id="form_data">
    <div class="modal-body">
        <div class="form-row mb-4">
            <div class="form-group col-md-6">
                <label for="inputEmail4">{{trans('nama')}}</label>
                <input type="text" class="form-control-rounded form-control" name="nama" placeholder="{{trans('nama')}}"
                    value="{{$data->name}}">
            </div>
            <div class="form-group col-md-6">
                <label for="inputEmail4">{{trans('email')??"Email"}}</label>
                <input type="email" class="form-control-rounded form-control" name="email" placeholder="Email"
                    value="{{$data->email}}">
            </div>
            <div class="form-group col-md-6">
                <label for="inputPassword4">Password</label>
                <input type="password" class="form-control-rounded form-control" id="inputPassword4"
                    placeholder="Password" name="password">
                <span>Kosongkan Jika Tidak Di ubah</span>
            </div>
            <div class="form-group col-md-6">
                <label for="inputPassword4">Role</label>
                <select name="role[]" class="select2 form-control-rounded form-control" multiple>
                    <option value=""></option>
                    @foreach ($role as $key)
                    <option value="{{$key}}" {{$data->hasRole($key) ? 'selected':'' }}>{{$key}}</option>

                    @endforeach
                </select>
            </div>
            <div class="form-group col-md-6">
                <label for="inputPassword4">Status</label>
                <select name="status" class="select2 form-control-rounded form-control">
                    <option value="1" {{$data->status==1?"selected":""}}>Active</option>
                    <option value="0" {{$data->status==0?"selected":""}}>Suspend</option>

                </select>
            </div>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-dark btn-rounded mt-3 mb-3" data-dismiss="modal">Close</button>
            <button type="submit" class="btn btn-primary btn-rounded mt-3 mb-3">Update</button>
        </div>
    </div>
</form>
<script>
    $(".select2").select2({
    placeholder: "Pilih",
    allowClear: true
    });
    $("#form_data").submit(function (e) {
        e.preventDefault();
       $('#myModal').modal('hide')
        var form=$("#form_data").serialize();
       $.ajax({
           type: "POST",
           method:"PUT",
           url: "{{route('user.update',[$data->id])}}",
           data: form,
           dataType: "JSON",
           success: function (response) {
            if (response.status!="error") {
               Toast.fire({
                icon: 'success',
                title: response.msg
                });
                myTable.ajax.reload();

            } else {
                Swal.fire({
                position: 'top-end',
                icon: 'error',
                title: response.msg,
                showConfirmButton: false,
                showCloseButton:true
                })
            }
           },
           error:function(response)
           {
            Swal.fire({
                position: 'top-end',
                icon: 'error',
                title: response.msg,
                showConfirmButton: false,
                showCloseButton:true
                })
           }
       });
    });
</script>

resources/views/admin/user/index.blade.php
@extends('layouts.master')
@section('title', trans('user'))
@section('parentPageTitle', 'Admin')
@section('css')
<link rel="stylesheet" type="text/css" href="{{asset('plugins/table/datatable/datatables.css')}}">
<link rel="stylesheet" type="text/css" href="{{asset('plugins/table/datatable/custom_dt_customer.css')}}">
<link rel="stylesheet" type="text/css" href="{{asset('plugins/select2/select2.min.css')}}">
@endsection
@section('content')

<div class="row layout-spacing">
    <div class="col-lg-12">
        <div class="statbox widget box box-shadow">
            <div class="widget-header">
                <br>
                <div class="row">
                    <div class="col-md-5 col-sm-5 mb-4 mb-sm-0">
                        <h6 class="mt-3 mb-0"> </h6>
                    </div>
                    <div class="col-md-7 col-sm-7 text-sm-right">
                        <a href="{{route('user.create')}}" data-toggle="modal" data-target="#myModal"
                            class="btn btn-warning mb-4 mr-2 btn-rounded">{{trans('tambah')}} <i
                                class="flaticon-circle-plus ml-1"></i></a>
                        <a type="button" class="btn btn-primary mb-4 mr-2 btn-rounded">Export <i
                                class="flaticon-file ml-1"></i></a> </div>

                </div>
            </div>
            <div class="widget-content widget-content-area">
                <div class="table-responsive mb-4 style-1">

                    <table id="userss" class="table style-1  table-bordered table-hover">
                        <thead>
                            <tr>
                                <th> no. </th>
                                <th>{{trans('nama')}}</th>
                                <th>{{trans('Jenis Kelamin')}}</th>
                                <th>Email</th>
                                <th>{{trans('dibuat')}}</th>
                                <th>Status</th>
                                <th>{{trans('Type Member')}}</th>
                                <th>{{trans('Pajak')}}</th>
                                <th>{{trans('No CC')}}</th>
                                <th class="text-center">Action</th>
                            </tr>
                        </thead>

                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@section('js')
<script src="{{asset('plugins/table/datatable/datatables.js')}}"></script>
<script src="{{asset('plugins/select2/select2.min.js')}}"></script>

@endsection
@section('modal')
<div class="modal fade animated zoomInUp custo-zoomInUp" tabindex="-1" role="dialog"
    aria-labelledby="myExtraLargeModalLabel" aria-hidden="true" id="myModal">
    <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
        </div>
    </div>
</div>


@endsection
@section('script')
<script type="text/javascript">
    $("#myModal").on("show.bs.modal", function(e) {
        var link = $(e.relatedTarget);
        $(this).find(".modal-content").load(link.attr("href"));
    });
    // $(".select2").select2({
    //     placeholder: 'Cari',
    //     allowClear: true
    // });

var myTable=$('#userss').DataTable({
        processing: true,
        serverSide: true,
        pageLength:5,
       // lengthMenu:[[5,10,15,20,50,100],[5,10,15,20,50,100]],
        lengthMenu: [ 5, 10, 20, 50, 100 ],
        language: {
                paginate: {
                  previous: "<i class='flaticon-arrow-left-1'></i>",
                  next: "<i class='flaticon-arrow-right'></i>"
                },
                //info: "Showing page _PAGE_ of _PAGES_"
            },
        ajax: {
            url: '{{route("user.api")}}',
            method: 'POST'
        },
        columns: [
            {data: 'DT_RowIndex', orderable: false, searchable: false},
            {data: 'first_name', name: 'first_name'},
            {data: 'gender', name: 'gender'},
            {data: 'email', name: 'email'},
            {data: 'created_at', name: 'created_at'},
            {data: 'status', name: 'status'},
            {data: 'type', name: 'type'},
            {data: 'pajak', name: 'pajak'},
            {data: 'cc', name: 'cc'},
            {data: 'action', name: 'action',orderable: false, searchable: false}
        ],

    });
function hapus(id){

    swalWithBootstrapButtons.fire({
    title: 'Are you sure?',
    text: "You won't be able to revert this!",
    icon: 'warning',
    showCancelButton: true,
    confirmButtonText: 'Yes, delete it!',
    cancelButtonText: 'No, cancel!',
    reverseButtons: true,
    showLoaderOnConfirm: true,
    }).then((result) => {
  if (result.value) {
      $.ajax({
          type: "POST",
          method:"DELETE",
          url: "{{url('admin/user/')}}/"+id,
          data: {id:id},
          dataType: "JSON",
          success: function (response) {
              if (response.status!='error') {
                  swalWithBootstrapButtons.fire(
                'Deleted!',
                'Your file has been deleted.',
                'success',
                ''
                );
                Toast.fire({
                icon: 'success',
                title: 'Your User has been deleted.'
                });
                myTable.ajax.reload();
              } else {

              }
          }
      });
  } else if (
    /* Read more about handling dismissals below */
    result.dismiss === Swal.DismissReason.cancel
  ) {
    swalWithBootstrapButtons.fire(
      'Cancelled',
      'Your imaginary User is safe :)',
      'error'
    );
  }
})

 }

</script>
@endsection